///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
/////////////////////////////// 


function PLAYER:PERPBan ( banTime, banReason, ply  )
	local bannerName = "Autobot"
	if (ply && IsValid(ply)) then 
		bannerName = ply:Nick()
		ply:Notify("Player banned.")
	end
	
	self:PDBan(bannerName, banTime, banReason)
end

function BanPlayer ( Player, Cmd, Args ) end

function PLAYER:Kick2 (r) 
	self:Kick(r) 
end 
concommand.Add("perp_a_b", BanPlayer);

local function SetSpectate ( Player, Command, Args )
	if !Player:IsAdmin() then return false; end
	if (!Args[1]) then return; end
	
	local toBeBanned = Args[1];
	local toBeBannedPlayer;
	for k, v in pairs(player.GetAll()) do
		if (v:UniqueID() == toBeBanned) then
			toBeBannedPlayer = v;
		end
	end
	if (!toBeBannedPlayer) then Player:Notify("Could not find that player."); return; end
		
	Player:GetTable().Spectating = toBeBannedPlayer;
	
	Player:Spectate(OBS_MODE_CHASE)
	Player:SpectateEntity(toBeBannedPlayer) 
end
concommand.Add('perp_a_s', SetSpectate);
	
local function StopSpectate ( Player, Command, Args )
	if !Player:IsAdmin() then return false; end
	
	Player:GetTable().Spectating = nil;
	
	Player:Spectate(OBS_MODE_NONE);
	Player:UnSpectate();
	
	Player:KillSilent();
end
concommand.Add('perp_a_ss', StopSpectate);

local function blacklistPlayer ( Player, cmd, Args )
	if (!Player:IsAdmin()) then return; end
	if (!Args[1] || !Args[2]) then return; end
	
	local banTime = tonumber(Args[1]);
	local toBeBanned = Args[2];
	
	banTime = math.Clamp(banTime, 0, 720);
	
	local toBeBannedPlayer;
	for k, v in pairs(player.GetAll()) do
		if (v:UniqueID() == toBeBanned) then
			toBeBannedPlayer = v;
		end
	end
	if (!toBeBannedPlayer) then Player:Notify("Could not find that player."); return; end
	
	if (!GAMEMODE.teamToBlacklist[toBeBannedPlayer:Team()]) then
		Player:Notify("Missing blacklist conversion.");
	return; end
	
	if (Player:HasBlacklist(GAMEMODE.teamToBlacklist[toBeBannedPlayer:Team()])) then
		Player:Notify("They already have that blacklist!");
	return; end
	
	toBeBannedPlayer:GiveBlacklist(GAMEMODE.teamToBlacklist[toBeBannedPlayer:Team()], banTime);
	
	Player:Notify("Player blacklisted.");
	toBeBannedPlayer:Notify("You have been blacklisted by an admin.\n");
		
	if (toBeBannedPlayer:Team() == TEAM_POLICE) then
		GAMEMODE.Police_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_MEDIC) then
		GAMEMODE.Medic_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_FIREMAN) then
		GAMEMODE.Fireman_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_SWAT) then
		GAMEMODE.Swat_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_DISPATCHER) then
		GAMEMODE.Dispatcher_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_SECRET_SERVICE) then
		GAMEMODE.Secret_Service_Leave(toBeBannedPlayer);
	elseif (toBeBannedPlayer:Team() == TEAM_MAYOR) then
		toBeBannedPlayer:SetModel(Player.PlayerModel);
		toBeBannedPlayer.JobModel = nil;
		toBeBannedPlayer:EquipMains();
		toBeBannedPlayer:SetTeam(TEAM_CITIZEN);
		
		for k, v in pairs(player.GetAll()) do
			if (v != Player && v != toBeBannedPlayer) then
				v:Notify("The mayor has been impeached!");
			end
		end
	else
		Player:Notify("Error demoting player.");
		return;
	end
end
concommand.Add("perp_a_bl", blacklistPlayer);

local function blacklistPlayer ( Player, cmd, Args )
	if (!Player:IsAdmin()) then return; end
	
	if (!GAMEMODE.IsSerious) then
		Player:Notify("This isn't serious RP.");
		return;
	end
	
	if (!Args[1] || !Args[2]) then return; end
	
	local banTime = tonumber(Args[1]);
	local toBeBanned = Args[2];
	
	banTime = math.Clamp(banTime, 0, 720);
	
	local toBeBannedPlayer;
	for k, v in pairs(player.GetAll()) do
		if (v:UniqueID() == toBeBanned) then
			toBeBannedPlayer = v;
		end
	end
	if (!toBeBannedPlayer) then Player:Notify("Could not find that player."); return; end
	
	if (Player:HasBlacklist('b')) then
		Player:Notify("They already have that blacklist!");
	return; end
	
	Player:Notify("Player blacklisted.");
	toBeBannedPlayer:GiveBlacklist('b', banTime);
end
concommand.Add("perp_a_bs", blacklistPlayer);

function GM.ForceRename ( Player, cmd, Args )
	if (!Player:IsAdmin()) then return; end
	if (!Args[1]) then return; end
	
	local toBeBanned = Args[1];
		
	local toBeBannedPlayer;
	for k, v in pairs(player.GetAll()) do
		if (v:UniqueID() == toBeBanned) then
			toBeBannedPlayer = v;
		end
	end
	if (!toBeBannedPlayer) then Player:Notify("Could not find that player."); return; end
	//if (toBeBannedPlayer:IsSuperAdmin()) then Player:Notify("You cannot force that player to rename."); return; end
	
	Msg(Player:Nick() .. " forced " .. toBeBannedPlayer:Nick() .. " to rename.\n");
	
	tmysql.query("INSERT INTO `perp_bname` (`name`) VALUES ('" .. tmysql.escape(toBeBannedPlayer:GetRPName()) .. "')");
	timer.Simple(.5, http.Get, "http://www.pulsareffect.com/PERP2.5/push_bname.php", "", function ( ) end);
	timer.Simple(2, GAMEMODE.GatherInvalidNames);
	toBeBannedPlayer:ForceRename();
end
concommand.Add("perp_a_fr", GM.ForceRename);