///////////////////////////////
//  2009-2010 Pulsar Effect //
//    All rights reserved    //
///////////////////////////////
// This material may not be  //
//   reproduced, displayed,  //
//  modified or distributed  //
// without the express prior //
// written permission of the //
//   the copyright holder.   //
///////////////////////////////

local function PlayerSave ( ply )
	if (!IsValid(ply)) then
		timer.Stop(ourID);
		timer.Remove(ourID);
		return;
	end
			
	ply:Save();
end

GM.OrganizationData = {};
GM.OrganizationMembers = {};

function GM.LoadPlayerProfile ( Player )
	if (Player.AlreadyLoaded) then return false; end
	
	Player.SMFID = Player:SteamID()
	Player.Buddies = Player.Buddies or {}
	
	Msg("Loading " .. Player:Nick() .. "...\n");
	
	if (!Player.StartedSendingVars) then
		Player.StartedSendingVars = true;
	
		Msg("Starting var transfer to " .. Player:Nick() .. "...\n");
		local curNum = 5;
		for _, p in pairs(player.GetAll()) do
			if (p != Player && p.StringRedun) then
				for k, v in pairs(p.StringRedun) do
					curNum = curNum + .2;
					
					timer.Simple(curNum, function ( )
						if (Player && IsValid(Player)) then
							if (!p || !IsValid(p) || !p.StringRedun[k]) then
								umsg.Start("perp_umsg_f", Player);
								umsg.End();
							else
								Player:SendUMsgVar("perp_ums", Player, p, k, v.value, true);
							end
						end
					end);
				end
			end
		end
		
		umsg.Start("perp_expect", Player);
			umsg.Short((curNum - 5) * 5);
		umsg.End();
	end

	tmysql.query("SELECT `id`, `rp_name_first`, `rp_name_last`, `time_played`, `cash`, `model`, `items`, `skills`, `genes`, `formulas`, `organization`, `bank`, `vehicles`, `blacklists`, `ringtone`, `ammo_pistol`, `ammo_rifle`, `ammo_shotgun`, `fuelleft`, `lastcar` FROM `perp_users` WHERE `id`='" .. Player.SMFID .. "'", function ( PlayerInfo )
		if (!Player || !Player:IsValid() || !IsValid(Player)) then return end
	
		if (!PlayerInfo || !PlayerInfo[1]) then
			tmysql.query("INSERT INTO `perp_users` (`id`, `uid`, `steamid`, `rp_name_first`, `rp_name_last`, `genes`, `cash`, `blacklists`, `model`, `items`, `skills`, `formulas`, `organization`, `bank`, `vehicles`, `ringtones`, `ringtone`, `time_played`, `last_played`) VALUES ('" .. Player.SMFID .. "', '" .. Player:UniqueID() .. "', '" .. Player:SteamID() .. "', 'John', 'Doe', '5', '10000', '', '', '', '', '', '0', '0', '0', '', '1', '0', '0')", function ( )
			tmysql.query("INSERT INTO `perp_fuel` (`uid`) VALUES ('" .. Player:UniqueID() .. "')");
				if (!Player || !Player:IsValid() || !IsValid(Player)) then return end
				
				Player.CanSetupPlayer = true;
				GAMEMODE.LoadPlayerProfile(Player);
			end);
			return;
		end
		
		if (PlayerInfo[1][2] == "John" && PlayerInfo[1][3] == "Doe") then Player.CanSetupPlayer = true; end
		
		if (Player.CanSetupPlayer) then
			Msg("Allowing " .. Player:Nick() .. " to setup new player...\n");
			umsg.Start("perp_newchar", Player);
			umsg.End();
		else
			Player:DetectBaconBot();
		end
		
		Player.joinTime = CurTime();
		
		// Public UMsg Vars
		Player:SetUMsgString("rp_fname", PlayerInfo[1][2]);
		Player:SetUMsgString("rp_lname", PlayerInfo[1][3]);
		Player:SetUMsgInt("ringtone", tonumber(PlayerInfo[1][15]));
		
		// Ammo
		Player:GiveAmmo(tonumber(PlayerInfo[1][16]), 'pistol');
		Player:GiveAmmo(tonumber(PlayerInfo[1][17]), 'smg1');
		Player:GiveAmmo(tonumber(PlayerInfo[1][18]), 'buckshot');
		
		// Private UMsg Vars - This part only sets it for the server. It's also sent to the client via the next section.
		Player:SetPrivateInt("time_played", tonumber(PlayerInfo[1][4]), true);
		Player:SetPrivateInt("cash", tonumber(PlayerInfo[1][5]), true);
		Player:SetPrivateInt("bank", tonumber(PlayerInfo[1][12]), true);
		Player:SetPrivateString("blacklists", PlayerInfo[1][14]);
		Player:SetPrivateInt("fuelleft", tonumber(PlayerInfo[1][19]), true);
		Player:SetPrivateString("lastcar", PlayerInfo[1][20] or "a");
		
		if (PlayerInfo[1][14] != "") then
			Player:RecompileBlacklists();
		end
		
		// Model
		local modelInfo = GAMEMODE.ExplodeModelInfo(PlayerInfo[1][6]) or {};
		local theirNewModel = Player:GetModelPath(modelInfo.sex or "m", tonumber(modelInfo.face) or 1, tonumber(modelInfo.clothes) or 1);
		Player:SetModel(theirNewModel);
		Player:SetPrivateString("model", theirNewModel);
		Player.PlayerModel = theirNewModel;
		Player.PlayerSex = modelInfo.sex or "m";
		Player.PlayerClothes = modelInfo.clothes;
		Player.PlayerFace = tonumber(modelInfo.face) or 1;
		Player.PlayerItems = {}
		
		// Sending the above private UMsg vars to the client.
		umsg.Start("perp_startup", Player)
			umsg.String(tostring(PlayerInfo[1][4]));	// Time Played
			umsg.Long(tonumber(PlayerInfo[1][5])); 		// Cash
			umsg.Long(tonumber(PlayerInfo[1][12])); 	// Bank Cash
			umsg.Long(tonumber(PlayerInfo[1][19]));		// Fuel Left
			umsg.String(tostring(PlayerInfo[1][20]) or "");	// Last Car Used
			umsg.Short(GAMEMODE.CurrentTime);			// Game Time
			umsg.Short(GAMEMODE.CurrentDay);			// Game Day
			umsg.Short(GAMEMODE.CurrentMonth);			// Game Month
			umsg.Short(GAMEMODE.CurrentYear);			// Game Year
		umsg.End();
		
		// Load Items...
		umsg.Start("perp_items_init", Player)
			umsg.String(PlayerInfo[1][7]);
		umsg.End();
		
		Player:parseSaveString(PlayerInfo[1][7]);
		
		
		// Load Vehicles...
		timer.Simple(1, function ( )
			if (Player && IsValid(Player)) then
				umsg.Start("perp_vehicles_init", Player)
					umsg.String(PlayerInfo[1][13]);
				umsg.End();
			end
		end);
		
		Player.Vehicles = {};
		Player:parseVehicleString(PlayerInfo[1][13]);
		
		// mixtures
		Player:SetPrivateString("mixtures", PlayerInfo[1][10]);
		
		// Skills
		local ExplodeSkills = string.Explode(";", PlayerInfo[1][8]);
		for i = 1, #SKILLS_DATABASE do	
			if ExplodeSkills[i] && (i != #ExplodeSkills) then
				Player:SetPrivateInt("s_" .. i, tonumber(ExplodeSkills[i]));
				local postLevel = Player:GetPERPLevel(SKILLS_DATABASE[i][1]);
				Player:AchievedLevel(SKILLS_DATABASE[i][1], tonumber(postLevel));
			end
		end
		
		// Genes
		local ExplodeGenes = string.Explode(";", PlayerInfo[1][9]);
		
		if (#ExplodeGenes > 1) then
			for i = 1, #GENES_DATABASE do			
				if ExplodeGenes[i + 1] && (i != #ExplodeGenes) then
					Player:SetPrivateInt("g_" .. i, tonumber(ExplodeGenes[i + 1]));
					local postLevel = Player:GetPERPLevel(GENES_DATABASE[i][1]);
					Player:AchievedLevel(GENES_DATABASE[i][1], tonumber(postLevel));
				end
			end
		end
		
		if (ExplodeGenes[1]) then
			Player:SetPrivateInt("gpoints", tonumber(ExplodeGenes[1]));
		end
		
		// Check his name...
		if (!Player.CanSetupPlayer && !GAMEMODE.IsValidName(Player:GetFirstName(), Player:GetLastName())) then
			Player:ForceRename();
		end
		
		// Organization
		local org = tonumber(PlayerInfo[1][11]);
		if (org != 0) then
			Player:SetUMsgInt("org", org);
			
			if (!GAMEMODE.OrganizationMembers[org]) then
				GAMEMODE.FetchOrganizationData(org);
			end
		end
		
		// Set Varaibles
		Player.AlreadyLoaded = true;
		
		local ourID = Player:SteamID();
		timer.Create(ourID, 60, 0, PlayerSave, Player);
		
		// Make them bitches load their weapons
		Player:EquipMains();
	end);
end
concommand.Add('perp_lp', GM.LoadPlayerProfile);

function GM.NewCharacterCreation ( Player, Cmd, Args )
	if (!Player.CanSetupPlayer) then return false; end
	
	Player.CanSetupPlayer = nil;
	
	local Model = Args[1];
	local FirstName = string.upper(string.sub(Args[2], 1, 1)) .. string.lower(string.sub(Args[2], 2));
	local LastName = string.upper(string.sub(Args[3], 1, 1)) .. string.lower(string.sub(Args[3], 2));
	
	if (!Model || !FirstName || !LastName) then
		Player:ForceRename();
		return;
	end
	
	// Model Stuff
	local modelInfo = GAMEMODE.ExplodeModelInfo(Model) or {};
	local theirNewModel = Player:GetModelPath(modelInfo.sex or "m", tonumber(modelInfo.face) or 1, tonumber(modelInfo.clothes) or 1);
	
	Player:SetModel(theirNewModel);
	Player.PlayerModel = theirNewModel;
	tmysql.query("UPDATE `perp_users` SET `model`='" .. modelInfo.sex .. "_" .. modelInfo.face .. "_" .. modelInfo.clothes .. "' WHERE `id`='" .. Player.SMFID .. "'");
	
	if (!GAMEMODE.IsValidName(FirstName, LastName)) then 
		Player:ForceRename();
		return; 
	end
	
	tmysql.query("SELECT `id` FROM `perp_users` WHERE `rp_name_first`='" .. FirstName .. "' AND `rp_name_last`='" .. LastName .. "' LIMIT 1", function ( someoneElseHas )
		if (!Player or !IsValid(Player) or !Player:IsValid()) then return; end
				
		if (someoneElseHas && someoneElseHas[1] && someoneElseHas[1][1]) then
			Player:Notify("That name is already taken.\n");
			Player:ForceRename();
			return; 
		end
	
		Player:SetUMsgString("rp_fname", FirstName);
		Player:SetUMsgString("rp_lname", LastName);
		
		Player:DetectBaconBot();
		
		tmysql.query("UPDATE `perp_users` SET `rp_name_first`='" .. FirstName .. "',`rp_name_last`='" .. LastName .. "' WHERE `id`='" .. Player.SMFID .. "'");
	end);
end
concommand.Add('perp_nc', GM.NewCharacterCreation);

function GM.ChangeName ( Player, Cmd, Args )
	local FirstName = string.upper(string.sub(Args[1], 1, 1)) .. string.lower(string.sub(Args[1], 2));
	local LastName = string.upper(string.sub(Args[2], 1, 1)) .. string.lower(string.sub(Args[2], 2));
	
	if (!FirstName || !LastName) then return; end
	
	if (!GAMEMODE.IsValidName(FirstName, LastName)) then 
		Player:ForceRename();
		return; 
	end
	
	tmysql.query("SELECT `id` FROM `perp_users` WHERE `rp_name_first`='" .. FirstName .. "' AND`rp_name_last`='" .. LastName .. "' LIMIT 1", function ( someoneElseHas )
		if (!Player or !IsValid(Player) or !Player:IsValid()) then return; end
		
		if (someoneElseHas && someoneElseHas[1] && someoneElseHas[1][1]) then
			Player:Notify("That name is already taken.\n");
			Player:ForceRename();
			return; 
		end
	
		if (!Player.CanRenameFree) then
			if (Player:GetCash() < GAMEMODE.RenamePrice) then
				return;
			end
			
			Player:TakeCash(GAMEMODE.RenamePrice, true);
		end
		
		Player.CanRenameFree = nil;
		
		Player:SetUMsgString("rp_fname", FirstName);
		Player:SetUMsgString("rp_lname", LastName);
		
		tmysql.query("UPDATE `perp_users` SET `rp_name_first`='" .. FirstName .. "',`rp_name_last`='" .. LastName .. "' WHERE `id`='" .. Player.SMFID .. "'");
	end);
end
concommand.Add("perp_encrypt3D_cn", GM.ChangeName);

function GM.ChangeFace ( Player, Cmd, Args )
	if (!Player) then return; end
	if (!Args[1]) then return; end
	if (Player:Team() != TEAM_CITIZEN) then return; end
	
	local Model = Args[1];
	
	// Model Stuff
	local modelInfo = GAMEMODE.ExplodeModelInfo(Model);
	if (!modelInfo) then return; end
	
	local newSex = SEX_MALE;
	if (modelInfo.sex == 'f') then newSex = SEX_FEMALE; end
	if (tonumber(modelInfo.sex) == 2) then newSex = SEX_FEMALE; end
	if (Player:GetSex() != newSex) then return; end
	if (Player:GetClothes() != modelInfo.clothes) then return; end
	
	Player:TakeCash(GAMEMODE.FacialPrice, true);
	
	local theirNewModel = Player:GetModelPath(modelInfo.sex or "m", tonumber(modelInfo.face) or 1, tonumber(modelInfo.clothes) or 1);
	
	Player:SetModel(theirNewModel);
	Player.PlayerModel = theirNewModel;
	tmysql.query("UPDATE `perp_users` SET `model`='" .. modelInfo.sex .. "_" .. modelInfo.face .. "_" .. modelInfo.clothes .. "' WHERE `id`='" .. Player.SMFID .. "'");
	
	Player:SetPrivateString("model", theirNewModel);
	Player.PlayerSex = modelInfo.sex or "m";
	Player.PlayerClothes = modelInfo.clothes;
	Player.PlayerFace = tonumber(modelInfo.face) or 1;
end
concommand.Add("perp_cf", GM.ChangeFace);

function GM.ChangeClothes ( Player, Cmd, Args )
	if (!Player) then return; end
	if (!Args[1]) then return; end
	if (Player:Team() != TEAM_CITIZEN) then return; end
	
	local Model = Args[1];
	
	// Model Stuff
	local modelInfo = GAMEMODE.ExplodeModelInfo(Model);
	if (!modelInfo) then Msg("fail info\n"); return; end
	
	local newSex = SEX_MALE;
	if (modelInfo.sex == 'f') then newSex = SEX_FEMALE; end
	if (tonumber(modelInfo.sex) == 2) then newSex = SEX_FEMALE; end
	if (Player:GetSex() != newSex) then return; end
	if (Player:GetFace() != modelInfo.face) then return; end
	
	Player:TakeCash(GAMEMODE.ClothesPrice, true);
	
	local theirNewModel = Player:GetModelPath(modelInfo.sex or "m", tonumber(modelInfo.face) or 1, tonumber(modelInfo.clothes) or 1);
	
	Player:SetModel(theirNewModel);
	Player.PlayerModel = theirNewModel;
	tmysql.query("UPDATE `perp_users` SET `model`='" .. modelInfo.sex .. "_" .. modelInfo.face .. "_" .. modelInfo.clothes .. "' WHERE `id`='" .. Player.SMFID .. "'");
	
	Player:SetPrivateString("model", theirNewModel);
	Player.PlayerSex = modelInfo.sex or "m";
	Player.PlayerClothes = modelInfo.clothes;
	Player.PlayerFace = tonumber(modelInfo.face) or 1;
end
concommand.Add("perp_cc", GM.ChangeClothes);

function GM.ChangeSex ( Player, Cmd, Args )
	if (!Player) then return; end
	if (Player:Team() != TEAM_CITIZEN) then return; end
	
	
	// Model Stuff
	local newSex = "m";
	if (Player:GetSex() == SEX_MALE) then newSex = "f"; end
	
	local modelInt = SEX_MALE;
	if (newSex == "f") then modelInt = SEX_FEMALE; end

	Player:TakeCash(GAMEMODE.SexChangePrice, true);
	
	local theirNewModel = Player:GetModelPath(newSex, 1, 1);
	
	Player:SetModel(theirNewModel);
	Player.PlayerModel = theirNewModel;
	tmysql.query("UPDATE `perp_users` SET `model`='" .. modelInt .. "_1_1' WHERE `id`='" .. Player.SMFID .. "'");
	
	Player:SetPrivateString("model", theirNewModel);
	Player.PlayerSex = modelInt;
	Player.PlayerClothes = 1;
	Player.PlayerFace = 1;
end
concommand.Add("perp_cs", GM.ChangeSex);

function GM.Typing ( Player, Cmd, Args )
	if (Args[1] && tostring(Args[1]) == "1") then
		Player:SetUMsgInt("typing", 1);
		Player.StartedTyping = CurTime();
	else
		Player.StartedTyping = nil;
		Player:SetUMsgInt("typing", nil);
	end
end
concommand.Add("pt", GM.Typing);

function GM.AddBuddy ( Player, Cmd, Args )
	if (!Args[1] || !Player.Buddies) then return; end
	if (tostring(tonumber(Args[1])) != tostring(Args[1])) then return; end
	
	table.insert(Player.Buddies, Args[1]);
end
concommand.Add("perp_ab", GM.AddBuddy);

function GM.RemoveBuddy ( Player, Cmd, Args )
	if (!Args[1] || !Player.Buddies) then return; end
	if (tostring(tonumber(Args[1])) != tostring(Args[1])) then return; end
	
	for k, v in pairs(Player.Buddies) do
		if (v == Args[1]) then
			Player.Buddies[k] = nil;
		end
	end
end
concommand.Add("perp_rb", GM.RemoveBuddy);

function GM.BankDeposit ( Player, Cmd, Args )
	if (!Args[1]) then return; end
	
	local toTake = tonumber(Args[1]);
	
	if (toTake <= 0) then return; end
	if (Player:GetCash() < toTake) then return; end
	
	Player:TakeCash(toTake, true);
	Player:GiveBank(toTake, true);
end
concommand.Add("perp_b_d", GM.BankDeposit);

function GM.BankWithdraw ( Player, Cmd, Args )
	if (!Player:NearNPC(2)) then return; end
	if (!Args[1]) then return; end
	
	local toTake = tonumber(Args[1]);
	
	if (toTake <= 0) then return; end
	if (Player:GetBank() < toTake) then return; end
	if ((Player:GetCash() + toTake) > MAX_CASH) then return; end
	
	Player:GiveCash(toTake, true);
	Player:TakeBank(toTake, true);
end
concommand.Add("perp_b_w", GM.BankWithdraw);

// Event Start Script
function GM.StartEvent ( Player, Cmd, Args )
	if Player:GetLevel() > 0 then return false; end
	local Event = Args[1];
	
	if !file.Exists('../gamemodes/PERP3/gamemode/events/' .. Event .. '.lua') then
		Player:PrintMessage(HUD_PRINTCONSOLE, "That event does not exist.");
		return false;
	end
	
	include('perp3/gamemode/events/' .. Event .. '.lua');
end
concommand.Add("perp2_encrypt3D_events", GM.StartEvent);

/* 
// Function AutoStart Zombie (Load this on halloween)
function AutoStartZombie ()
	include('perp3/gamemode/events/zombie.lua');
end;
timer.Simple(660, AutoStartZombie);

function GlobalMessages ()
	for k, v in pairs(player.GetAll()) do
		v:Notify("ALL DAY HALLOWEEN ZOMBIE EVENT!");
		v:Notify("10 Minutes until Zombie Event!");
	end;
	
	timer.Simple(60, function() for k, v in pairs(player.GetAll()) do v:Notify("9 Minutes until Zombie Event!") end end );
	timer.Simple(120, function() for k, v in pairs(player.GetAll()) do v:Notify("8 Minutes until Zombie Event!") end end );
	timer.Simple(180, function() for k, v in pairs(player.GetAll()) do v:Notify("7 Minutes until Zombie Event!") end end );
	timer.Simple(240, function() for k, v in pairs(player.GetAll()) do v:Notify("6 Minutes until Zombie Event!") end end );
	timer.Simple(300, function() for k, v in pairs(player.GetAll()) do v:Notify("5 Minutes until Zombie Event!") end end );
	timer.Simple(360, function() for k, v in pairs(player.GetAll()) do v:Notify("4 Minutes until Zombie Event!") end end );
	timer.Simple(420, function() for k, v in pairs(player.GetAll()) do v:Notify("3 Minutes until Zombie Event!") end end );
	timer.Simple(480, function() for k, v in pairs(player.GetAll()) do v:Notify("2 Minutes until Zombie Event!") end end );
	timer.Simple(540, function() for k, v in pairs(player.GetAll()) do v:Notify("60 Seconds until Zombie Event!") end end );
	timer.Simple(555, function() for k, v in pairs(player.GetAll()) do v:Notify("45 Seconds until Zombie Event!") end end );
	timer.Simple(570, function() for k, v in pairs(player.GetAll()) do v:Notify("30 Seconds until Zombie Event!") end end );
	timer.Simple(580, function() for k, v in pairs(player.GetAll()) do v:Notify("20 Seconds until Zombie Event!") end end );
	timer.Simple(590, function() for k, v in pairs(player.GetAll()) do v:Notify("10 Seconds until Zombie Event!") end end );
	timer.Simple(595, function() for k, v in pairs(player.GetAll()) do v:Notify("5 Seconds until Zombie Event!") end end );
	timer.Simple(596, function() for k, v in pairs(player.GetAll()) do v:Notify("4 Seconds until Zombie Event!") end end );
	timer.Simple(597, function() for k, v in pairs(player.GetAll()) do v:Notify("3 Seconds until Zombie Event!") end end );
	timer.Simple(598, function() for k, v in pairs(player.GetAll()) do v:Notify("2 Seconds until Zombie Event!") end end );
	timer.Simple(599, function() for k, v in pairs(player.GetAll()) do v:Notify("1 Seconds until Zombie Event!") end end );
end;
timer.Simple(60, GlobalMessages);
*/